package ui

import (
	"log"
	"net/http"
	"strconv"

	"github.com/gin-gonic/gin"

	"git.jmbit.de/filegate/filegate/db"
	"git.jmbit.de/filegate/filegate/utils"
	"git.jmbit.de/filegate/filegate/web/templates"
)

func getFileListPage(c *gin.Context) {
	page, err := strconv.Atoi(c.DefaultQuery("page", "1"))
	if err != nil {
		log.Println(err)
	}
	count, err := strconv.Atoi(c.DefaultQuery("count", "50"))
	if err != nil {
		log.Println(err)
	}
	fileList, err := db.GetFileList(page, count, c)
	if err != nil {
		log.Println(err)
	}
	lowestEntry := (page - 1) * count
	highestEntry := page * count
	fileListPage := fileList[lowestEntry:highestEntry]

	//content := gin.H{
	//	"fileList":     fileListPage,
	//	"error":        err,
	//	"page":         page,
	//	"count":        count,
	//	"totalEntries": len(fileList),
	//}
	c.HTML(
		http.StatusOK,
		"",
		templates.FileListPage(utils.GenMetaContent(c), "Files", fileListPage, err),
	)
}
